-- Mod: Animal Status
-- Author: Oectacan

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

animalStatus = {};
animalStatus.version = getXMLString(modDesc, "modDesc.version");
animalStatus.modDirectory = g_currentModDirectory;
hudActive = false;

addModEventListener(animalStatus);

function animalStatus:loadMap()

	print("--- Animal Status v.:" .. self.version .. ", by Oectacan loaded");

end;

function animalStatus:keyEvent(unicode, sym, modifier, isDown)
end;

function animalStatus:mouseEvent(posX, posY, isDown, isUp, button)
end;

function animalStatus:deleteMap()
end;

function animalStatus:update(dt)

	if InputBinding.hasEvent(InputBinding.AS_TRIGER) then
		hudActive =not hudActive;
	end;	

end;

function animalStatus:draw()

	if hudActive == true then

		local posX = 0.89; -- Data X position
		local posX2 = posX + 0.1; -- Data offset X position
		local posY = 0.8; -- Data Y position
		local paddingY = 0.005; -- Padding between blocks
		local fontSize = 0.010; -- Block font size
		local lineDist = fontSize + 0.002;  -- Distancr between lines
		setTextColor(1,1,1,1);
		
		--Chickens info
		if g_currentMission.husbandries.chicken.totalNumAnimals > 1 then
			setTextBold(true);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "Chickens: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, g_currentMission.husbandries.chicken.totalNumAnimals .. " pcs"); posY = posY - lineDist;
			setTextBold(false);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "eggs: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.chicken.numActivePickupObjects) .. " pcs"); posY = posY - lineDist - paddingY;
		end;

		--Sheeps info
		if g_currentMission.husbandries.sheep.totalNumAnimals > 0 then
			setTextBold(true);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "Sheeps :");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, g_currentMission.husbandries.sheep.totalNumAnimals .. " pcs"); posY = posY - lineDist;
			setTextBold(false);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "productivity: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.sheep.productivity * 100) .. "%"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "cleanliness: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.sheep.cleanlinessFactor * 100) .. "%"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "water: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.sheep:getFillLevel(FillUtil.FILLTYPE_WATER)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "grass: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.sheep:getFillLevel(FillUtil.FILLTYPE_GRASS_WINDROW) + g_currentMission.husbandries.sheep:getFillLevel(FillUtil.FILLTYPE_DRYGRASS_WINDROW)) .. " l"); posY = posY - lineDist;
			if g_currentMission.husbandries.sheep.currentPallet == nil then
				setTextAlignment(RenderText.ALIGN_LEFT);
				renderText(posX, posY, fontSize, "wool: ");
				setTextAlignment(RenderText.ALIGN_RIGHT);
				renderText(posX2, posY, fontSize, "n/a"); posY = posY - lineDist - paddingY;
			else
				setTextAlignment(RenderText.ALIGN_LEFT);
				renderText(posX, posY, fontSize, "wool: ");
				setTextAlignment(RenderText.ALIGN_RIGHT);
				renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.sheep.currentPallet.fillLevel) .. " l"); posY = posY - lineDist - paddingY;
			end;
		end;

		--Pigs info
		if g_currentMission.husbandries.pig.totalNumAnimals > 0 then
			setTextBold(true);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "Pigs: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, g_currentMission.husbandries.pig.totalNumAnimals .. " pcs"); posY = posY - lineDist;
			setTextBold(false);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "productivity: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig.productivity * 100) .. "%"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "cleanliness: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig.cleanlinessFactor * 100) .. "%"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "water: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_WATER)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "straw: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_STRAW)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "maize: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_MAIZE)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "grain: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_WHEAT) + g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_BARLEY)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "beans: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_RAPE) + g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_SUNFLOWER) + g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_SOYBEAN)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "earth fuits: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_POTATO) + g_currentMission.husbandries.pig:getFillLevel(FillUtil.FILLTYPE_SUGARBEET)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "liquid manure:");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig.liquidManureTrigger.fillLevel) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "manure: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.pig.manureFillLevel) .. " l"); posY = posY - lineDist - paddingY;
		end;

		--Cows info
		if g_currentMission.husbandries.cow.totalNumAnimals > 0 then
			setTextBold(true);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "Cows: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, g_currentMission.husbandries.cow.totalNumAnimals .. " pcs"); posY = posY - lineDist;
			setTextBold(false);
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "productivity: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow.productivity * 100) .. "%"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "cleanliness: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow.cleanlinessFactor * 100) .. "%"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "water: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow:getFillLevel(FillUtil.FILLTYPE_WATER)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "straw: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow:getFillLevel(FillUtil.FILLTYPE_STRAW)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "grass: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow:getFillLevel(FillUtil.FILLTYPE_GRASS_WINDROW)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "silos: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow:getFillLevel(FillUtil.FILLTYPE_DRYGRASS_WINDROW) + g_currentMission.husbandries.cow:getFillLevel(FillUtil.FILLTYPE_SILAGE)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "TMR: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow:getFillLevel(FillUtil.FILLTYPE_POWERFOOD)) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "liquid manure: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow.liquidManureTrigger.fillLevel) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "manure: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow.manureFillLevel) .. " l"); posY = posY - lineDist;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, fontSize, "milk: ");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX2, posY, fontSize, math.floor(g_currentMission.husbandries.cow.fillLevelMilk) .. " l"); posY = posY - lineDist - paddingY;
		end;
		setTextAlignment(RenderText.ALIGN_LEFT); -- other mods compability

	end;
end;